Attribute VB_Name = "SetCDLG"
'timer API
Public Declare Function SetTimer Lib "user32" ( _
       ByVal hWnd As Long, ByVal nIDEvent As Long, _
       ByVal uElapse As Long, ByVal lpTimerFunc As Long _
  ) As Long

Public Declare Function KillTimer Lib "user32" ( _
       ByVal hWnd As Long, ByVal nIDEvent As Long _
  ) As Long

'window functions
Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" ( _
        ByVal hWndParent As Long, _
        ByVal hwndChild As Long, _
        ByVal lpClassName As String, _
        ByVal lpWindowName As String _
   ) As Long
       
Public Declare Function SetWindowPos Lib "user32" ( _
        ByVal hWnd As Long, _
        ByVal hWia As Long, _
        ByVal x As Long, ByVal y As Long, _
        ByVal cx As Long, ByVal cy As Long, _
        ByVal wFlags As Long _
   ) As Long

Public Const SWP_NoSize = 1&
Public Const SWP_NoMove = 2&
Public Const SWP_NoZOrder = 4&
Public Const SWP_NoOwnerZOrder = &H200

'set dialog view style commands
Public Const DVS_List = &H702B&
Public Const DVS_Details = &H702C&
Public Const DVS_Tiles = &H702E&
Public Const DVS_Thumbnails = &H702D&

'use the SendMessage function to send a notification message to the column header
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" ( _
        ByVal hWnd As Long, _
        ByVal wMsg As Long, _
        ByVal wParam As Long, _
        ByRef lParam As Any _
   ) As Long

Public Const WM_COMMAND = &H111&
Private Const WM_NOTIFY As Long = &H4E

'notification message header
Private Type NMHDR
        hwndFrom As Long
        idFrom As Long
        code As Long
    End Type

Private Type NMHEADER
        hdr As NMHDR
        iItem As Long
        iButton As Long
        pitem As Long
    End Type

Private Const HDN_FIRST As Long = (-300)
Private Const HDN_ITEMCLICKW As Long = (HDN_FIRST - 22)


'need these publics to be addressed from the timer event handler
Public CurrentDialog As CommonDialog
Public DialogViewStyle As Long
Public TimerAgain As Boolean

Public Sub SetViewStyleAndSize()
  Dim cn$, r&, x&, y&
  
' set the view style of a CommonDialog for file open/save
' used in conjunction with a timer and the global DialogViewStyle and CurrentDialog
  Dim hWndDlg As Long, hWndWin As Long, hWndLV As Long, hWndColHd As Long
  If CurrentDialog Is Nothing Then Exit Sub
  hWndDlg = FindWindowEx(0&, 0&, vbNullString, CurrentDialog.DialogTitle)
  If hWndDlg <> 0 And hWndDlg <> -1 Then
     hWndWin = FindWindowEx(hWndDlg, 0&, "SHELLDLL_DefView", vbNullString)
     If hWndWin <> 0 And hWndWin <> -1 Then
        'set the view style
        SendMessage hWndWin, WM_COMMAND, DialogViewStyle, ByVal 0&
        If DialogViewStyle = DVS_Details Then
           Beep
           'get the ListView's hWnd
           hWndLV = FindWindowEx(hWndWin, 0&, "SysListView32", vbNullString)
           'get the ColumnHeaders hWnd
           hWndColHd = FindWindowEx(hWndLV, 0&, "SysHeader32", vbNullString)
           'now click on column 3 to sort for date
           Dim NMH As NMHEADER
           NMH.hdr.hwndFrom = hWndColHd
           NMH.hdr.code = HDN_ITEMCLICKW
           NMH.iItem = 3
           NMH.iButton = 0
           SendMessage hWndLV, WM_NOTIFY, 0, NMH
           'click again for descending order = newest files first
           'SendMessage hWndLV, WM_NOTIFY, 0, NMH
        End If
     End If
     'if wanted give the dialog a larger size here
     SetWindowPos hWndDlg, 0&, 0&, 0&, 800&, 600&, 0&
     '
  End If
End Sub

Public Sub TimerEvent(hWnd As Long, msg As Long, idTimer As Long, dwTime As Long)
  If Not TimerAgain Then
     TimerAgain = True 'only run once
     SetViewStyleAndSize
  End If
End Sub

